Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Types | Public Member Functions | Public Attributes | List of all members
faiss::IndexLSH Struct Reference

`#include <IndexLSH.h>`

Inheritance diagram for faiss::IndexLSH:

## Public Types
typedef unsigned char | uint8_t
Public Types inherited from faiss::Index
typedef long | idx_t
| all indices are this type

## Public Member Functions
| IndexLSH (idx_t d, int nbits, bool rotate_data=true, bool train_thresholds=false)
const float * | apply_preprocess (idx_t n, const float *x) const
virtual void | set_typename () override
virtual void | train (idx_t n, const float *x) override
virtual void | add (idx_t n, const float *x) override
virtual void | search (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels) const override
virtual void | reset () override
| removes all elements from the database.
void | transfer_thresholds (LinearTransform *vt)
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_INNER_PRODUCT)
virtual void | add_with_ids (idx_t n, const float *x, const long *xids)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const
virtual std::string | get_typename () const

## Public Attributes
int | nbits
| nb of bits per vector
int | bytes_per_vec
| nb of 8-bits per encoded vector
bool | rotate_data
| whether to apply a random rotation to input
bool | train_thresholds
| whether we train thresholds or use 0
RandomRotationMatrix | rrot
| optional random rotation
std::vector< float > | thresholds
| thresholds to compare with
std::vector< uint8_t > | codes
| encoded dataset
Public Attributes inherited from faiss::Index
std::string | index_typename
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Detailed Description

The sign of each vector component is put in a binary signature

Definition at line 25 of file IndexLSH.h.

## Member Function Documentation

void faiss::IndexLSH::add | ( | idx_t | n,
|  | const float * | x
| ) |  |
| overridevirtual

Add n vectors of dimension d to the index.

Vectors are implicitly assigned labels ntotal .. ntotal + n - 1 This function slices the input vectors in chuncks smaller than blocksize_add and calls add_core.

Parameters

  x | input matrix, size n * d

Implements faiss::Index.

Definition at line 124 of file IndexLSH.cpp.

const float * faiss::IndexLSH::apply_preprocess | ( | idx_t | n,
|  | const float * | x
| ) |  | const

Preprocesses and resizes the input to the size required to binarize the data

Parameters

  x | input vectors, size n * d

Returns
  output vectors, size n * bits. May be the same pointer as x, otherwise it should be deleted by the caller

Definition at line 59 of file IndexLSH.cpp.

void faiss::IndexLSH::search | ( | idx_t | n,
|  | const float * | x,
|  | idx_t | k,
|  | float * | distances,
|  | idx_t * | labels
| ) |  | const
| overridevirtual

query n vectors of dimension d to the index.

return at most k vectors. If there are not enough results for a query, the result array is padded with -1s.

Parameters

  x | input vectors to search, size n * d
  labels | output labels of the NNs, size n*k
  distances | output pairwise distances, size n*k

Implements faiss::Index.

Definition at line 137 of file IndexLSH.cpp.

void faiss::IndexLSH::train | ( | idx_t | n,
|  | const float * | x
| ) |  |
| overridevirtual

Perform training on a representative set of vectors

Parameters

  n | nb of training vectors
  x | training vecors, size n * d

Reimplemented from faiss::Index.

Definition at line 94 of file IndexLSH.cpp.

void faiss::IndexLSH::transfer_thresholds | ( | LinearTransform * | vt | ) |

transfer the thresholds to a pre-processing stage (and unset train_thresholds)

Definition at line 169 of file IndexLSH.cpp.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/IndexLSH.h
- /data/users/matthijs/github_faiss/faiss/IndexLSH.cpp